import type { IGomokuContext } from './types/context';
import type { IGomokuCountMap } from './types/count-map';
export declare class GomokuCountMap implements IGomokuCountMap {
    readonly context: Readonly<IGomokuContext>;
    protected readonly _mustWinPosSet: Array<Set<number>>;
    protected readonly _candidateCouldReachFinal: number[][];
    constructor(context: Readonly<IGomokuContext>);
    init(): void;
    forward(posId: number): void;
    revert(posId: number): void;
    mustWinPosSet(playerId: number): Iterable<number> & {
        size: number;
    };
    candidateCouldReachFinal(playerId: number, posId: number): boolean;
    protected _updateRelatedCouldReachFinal(centerPosId: number): void;
    protected _updateCouldReachFinal(posId: number, expiredBitset: number): void;
}
