import type { IGomokuContext } from './types/context';
import type { IGomokuCountMap } from './types/count-map';
import type { IGomokuCandidateState } from './types/misc';
import type { IGomokuSearcherContext } from './types/searcher-context';
import type { IGomokuState } from './types/state';
export interface IGomokuSearcherContextProps {
    readonly rootPlayerId: number;
    readonly context: Readonly<IGomokuContext>;
    readonly countMap: Readonly<IGomokuCountMap>;
    readonly state: Readonly<IGomokuState>;
}
export declare class GomokuSearcherContext implements IGomokuSearcherContext {
    readonly rootPlayerId: number;
    readonly context: Readonly<IGomokuContext>;
    readonly countMap: Readonly<IGomokuCountMap>;
    readonly state: Readonly<IGomokuState>;
    constructor(props: IGomokuSearcherContextProps);
    init(rootPlayerId: number): void;
    forward(posId: number, playerId: number): void;
    revert(posId: number): void;
    expand(nextPlayerId: number, candidates: IGomokuCandidateState[], minMultipleOfTopScore: number, MAX_SIZE?: number): number;
    topCandidate(nextPlayerId: number): IGomokuCandidateState | undefined;
    score(nextPlayerId: number): number;
    couldReachFinal(nextPlayerId: number): boolean;
}
