import type { IGomokuCandidateState } from '../types/misc';
import type { IGomokuSearcher } from '../types/searcher';
import type { IGomokuSearcherContext } from '../types/searcher-context';
export interface IAlphaBetaSearcherProps {
    MAX_CANDIDATE_COUNT: number;
    MIN_PROMOTION_SCORE: number;
    MIN_MULTIPLE_OF_TOP_SCORE: number;
    searchContext: IGomokuSearcherContext;
    deeperSearcher: IGomokuSearcher;
}
export declare class AlphaBetaSearcher implements IGomokuSearcher {
    readonly MAX_CANDIDATE_COUNT: number;
    readonly MIN_PROMOTION_SCORE: number;
    readonly MIN_MULTIPLE_OF_TOP_SCORE: number;
    readonly searchContext: Readonly<IGomokuSearcherContext>;
    readonly deeperSearcher: IGomokuSearcher;
    protected readonly _candidateCache: IGomokuCandidateState[];
    constructor(props: IAlphaBetaSearcherProps);
    search(rootPlayerId: number, alpha: number, beta: number, cur: number): number | -1;
}
