import type { IGomokuCandidateState } from '../types/misc';
import type { IGomokuSearcher } from '../types/searcher';
import type { IGomokuSearcherContext } from '../types/searcher-context';
export interface INarrowSearcherProps {
    MAX_SEARCH_DEPTH: number;
    MAX_CANDIDATE_COUNT: number;
    MIN_PROMOTION_SCORE: number;
    MIN_MULTIPLE_OF_TOP_SCORE: number;
    searcherContext: IGomokuSearcherContext;
    deeperSearcher: IGomokuSearcher;
}
export declare class NarrowSearcher implements IGomokuSearcher {
    readonly MAX_SEARCH_DEPTH: number;
    readonly MAX_CANDIDATE_COUNT: number;
    readonly MIN_PROMOTION_SCORE: number;
    readonly MIN_MULTIPLE_OF_TOP_SCORE: number;
    readonly searcherContext: Readonly<IGomokuSearcherContext>;
    readonly deeperSearcher: IGomokuSearcher;
    protected readonly _candidatesListCache: Record<number, IGomokuCandidateState[]>;
    constructor(props: INarrowSearcherProps);
    search(curPlayerId: number, alpha: number, beta: number, cur: number): number;
    protected _getCandidates(cur: number): IGomokuCandidateState[];
}
