import type { IGomokuContext } from './types/context';
import type { IGomokuCountMap } from './types/count-map';
import type { IGomokuPiece, IShapeScoreMap } from './types/misc';
import type { IGomokuSearcher } from './types/searcher';
import type { IGomokuSearcherContext } from './types/searcher-context';
import type { IGomokuState } from './types/state';
export interface IGomokuSolutionProps {
    MAX_ROW: number;
    MAX_COL: number;
    MAX_ADJACENT?: number;
    MAX_DISTANCE_OF_NEIGHBOR?: number;
    MIN_MULTIPLE_OF_TOP_SCORE?: number;
    scoreMap?: IShapeScoreMap;
    deeperSearcher?(searcherContext: IGomokuSearcherContext): IGomokuSearcher;
}
export declare class GomokuSolution {
    readonly MIN_MULTIPLE_OF_TOP_SCORE: number;
    readonly context: Readonly<IGomokuContext>;
    readonly countMap: Readonly<IGomokuCountMap>;
    readonly state: Readonly<IGomokuState>;
    protected readonly _searcherContext: IGomokuSearcherContext;
    protected readonly _searcher: IGomokuSearcher;
    constructor(props: IGomokuSolutionProps);
    init(pieces: ReadonlyArray<IGomokuPiece>): void;
    forward(r: number, c: number, playerId: number): void;
    revert(r: number, c: number): void;
    minimaxSearch(nextPlayerId: number): [r: number, c: number];
}
