import type { IDeepSearcherProps } from '../searcher/deep';
import type { INarrowSearcherProps } from '../searcher/narrow';
import type { IShapeScoreMap } from '../types/misc';
import type { IGomokuSearcher } from '../types/searcher';
import type { IGomokuSearcherContext } from '../types/searcher-context';
export declare type INarrowSearchOption = Omit<INarrowSearcherProps, 'searcherContext' | 'deeperSearcher'>;
export declare type IDeepSearcherOption = Omit<IDeepSearcherProps, 'searcherContext'>;
interface IProps {
    narrowSearcherOptions: INarrowSearchOption[];
    deepSearcherOption: IDeepSearcherOption;
    searchContext: IGomokuSearcherContext;
}
export declare const createMinimaxSearcher: (props: IProps) => IGomokuSearcher;
export declare const createDefaultMinimaxSearcher: (scoreMap: Readonly<IShapeScoreMap>, searchContext: IGomokuSearcherContext, options: {
    MAX_ADJACENT: number;
    MIN_MULTIPLE_OF_TOP_SCORE: number;
}) => IGomokuSearcher;
export {};
